
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Hello World感知机，懂你我心才安息 (深度学习入门系列之五) / iVAN</title>

    <meta name="description" content="Hello World感知机，懂你我心才安息 (深度学习入门系列之五) 更多深度文章,请关注云计算频道:https://yq.aliyun.com/cloud 系列文章: 一入侯门&quot;深&quot;似海,深度学习深几许(深度学习入门系列之一) 人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二) 神经网络不胜语,M-P模型似可寻(深度学习入门系列之三) &quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四) 原文再续,书接上回. 5.1 网之初,感知机 我们知道 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Hello World感知机，懂你我心才安息 (深度学习入门系列之五)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>更多深度文章，请关注云计算频道：https://yq.aliyun.com/cloud<br /></b></p>
<hr>
<br /><b>系列文章：</b></p>
<p>一入侯门“深”似海，深度学习深几许（深度学习入门系列之一）</p>
<p>人工“碳”索意犹尽，智能“硅”来未可知（深度学习入门系列之二）</p>
<p>神经网络不胜语，M-P模型似可寻（深度学习入门系列之三）</p>
<p>“机器学习”三重门，“中庸之道”趋若人（深度学习入门系列之四）</p>
<hr>
<br />原文再续，书接上回。</p>
<h2>5.1 网之初，感知机</h2>
<p>我们知道，《三字经》里开篇第一句就是：“人之初，性本善”。那么对于神经网络来说，这句话就要改为：“网之初，感知机”。感知机（</p>
<p>Perceptrons ），基本上来说，是一切神经网络学习的起点。</p>
<p>很多有关神经网络学习（包括深度学习）的教程，在提及感知机时，都知道绕不过，但也仅仅一带而过。学过编程的同学都知道，不论是哪门什么语言，那个神一般存在的第一个程序——“Hello World”，对初学者有多么重要，可以说，它就是很多人“光荣与梦想”开始的地方。</p>
<p>而感知机学习，就是神经网络学习的“Hello World”，所以对于初学者来说，也值得我们细细玩味。因此，下面我们就给予详细讲解。</p>
<h2>5.2 感性认识“感知机”</h2>
<p>在第3小节中，我们已经提到，所谓的感知机，其实就是一个由两层神经元构成的网络结构，它在输入层接收外界的输入，通过激活函数（含阈值）的变换，把信号传送至输出层，因此它也称之为“阈值逻辑单元（threshold logic unit）”。</p>
<p>麻雀虽小，五脏俱全。感知机虽然简单，但已初具神经网络的必备要素。在前面我们也提到，所有“有监督”的学习，在某种程度上，都是分类（classification）学习算法。而感知机就是有监督的学习，所以，它也是一种分类算法。下面我们就列举一个区分“西瓜和香蕉”的经典案例，来看看感知机是如何工作的[1]。</p>
<p>为了简单起见，我们就假设西瓜和香蕉都仅有两个特征（feature）：形状和颜色，其它特征暂不考虑。这两个特征都是基于视觉刺激而得到的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2RjYmNiZWFiNmMzZmFmMDU3MTA1MTg3NmJkZmQxMTRhM2U5NWUxMTIuanBlZw==.jpg"></p>
<p>图5-1 感知机学习算法</p>
<p>假设特征<i>x</i><sub>1</sub>代表输入颜色，特征<i>x</i><sub>2</sub>代表形状，权重<i>w</i><sub>1</sub>和<i>w</i><sub>2</sub>默认值都为1，为了进一步简化，我们把阈值<i>θ</i>（亦有教程称之为偏值——bias）设置为0。为了标识方便，我们将感知器输出为“1”，代表判定为“西瓜”，而输出为“0”，代表判定为“香蕉”。当然了，如果有更多类别的物品，我们就用更多的数字来标记即可。</p>
<p>为了方便机器计算，我们对颜色和形状这两个特征，给予不同的值，以示区别。比如，颜色这个特征为绿色时，<i>x</i><sub>1</sub>取值为1，而当颜色为黄色时，<i>x</i><sub>1</sub>取值为-1；类似地，如果形状这个特征为圆形，<i>x</i><sub>2</sub>取值为1，反之，形状为弯曲状时，<i>x</i><sub>2</sub>取值为-1，如表5-1所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzBmZDRkZGFkODMzY2QwZDc0MjUzYWQ0MWVhYTUzZjJhNWQ1MmU1MDkuanBlZw==.jpg"></p>
<p>这样一来，可以很容易依据图5-1所示的公式，对于西瓜、香蕉做鉴定（即输出函数<i>f</i>的值），其结果分别如图5-2（a）所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRmNTY0MDY0ZWI0YmFiM2NkZDE3OGM0YThhZDgzMzBjNjNiOTY1YjIuanBlZw==.jpg"></p>
<p>图5-2 感知器的输出</p>
<p>从图5-2（a）所示的输出可以看到，对西瓜的判定输出结果是2，而香蕉的为-2。而我们先前预定的规则是：函数输出为1，则判定为西瓜，输出为0，则判定为香蕉，那么如何将2或-2这样的分类结果，变换成预期的分类表达呢，这个时候，就需要激活函数上场了！</p>
<p>这里，我们使用了最为简单的阶跃函数（step function）。在阶跃函数中，输出规则非常简单：当<i>x</i>&gt;0时，<i>f</i>(<i>x</i>)输出为1，否则输出0。通过激活函数的“润滑”之后，结果就变成我们想要的样子（如图5-2-b所示）。就这样，我们就搞定了西瓜和香蕉的判定。</p>
<p>这里需要说明的是，对象的不同特征（比如水果的颜色或形状等），只要用不同数值区分表示开来即可，具体用什么样的值，其实并无大碍。</p>
<p>但你或许会疑惑，这里的阈值（threshold）θ和两个连接权值<i>w<sub>1</sub></i>和<i>w<sub>2</sub></i>，为啥就这么巧分别就是0、1、1呢？如果取其它数值，会有不同的判定结果吗？</p>
<p>这是个好问题。事实上，我们并不能一开始就知道这几个参数的取值，而是一点点地非常苦逼地“折腾试错”（Try-Error）出来的，而这里的“折腾试错”其实就是感知机的学习过程！</p>
<p>下面，我们就聊聊最简单的神经网络——感知机它是如何学习的？</p>
<h2>5.3 感知机是如何学习的？</h2>
<p>中国有句古话：“知错能改，善莫大焉。”说得就是“犯了错误而能改正，没有比这更好的事了”。</p>
<p>放到机器学习领域，这句话显然属于“监督学习”的范畴。因为“知错”，就表明它事先已有了事物的评判标准，如果你的行为不符合（或说偏离）这些标准，那么就要根据“偏离的程度”，来“改善”自己的行为。</p>
<p>下面，我们就根据这个思想，来制定感知机的学习规则。从前面讨论中我们已经知道，感知机学习属于“有监督学习”（即分类算法）。感知机是有明确的目的导向的，这有点类似于“不管白猫黑猫，抓住老鼠就是好猫”，不管是什么样的学习规则，能达到良好的分类目的，就是好学习规则。</p>
<p>我们知道，对象本身的特征值，一旦确定下来就不会变化。因此，<b>所谓神经网络的学习规则，就是调整权值和阈值的规则（</b>这个结论对于深度学习而言，依然是适用的）<b>。</b></p>
<p>假设我们的规则是这样的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzJlNzQ2NzgxZjUwZmVkMWE2NzMxZTM5YTk3ZTQ3MTQ0YWYwYThhZjEuanBlZw==.jpg"></p>
<p>其中<i>ep<br />
= y</i>-<i> y’</i>，<i>y</i>为期望输出，<i>y’</i>是实际输出，所以，具体说来，<i>ep</i>是二者的差值。在后面，读者朋友可以看到，这个“落差”就是整个网络中权值和阈值的调整动力。因为，很显然，如果<i>ep</i>为0，那么新、旧权值和阈值都是一样的，网络就稳定可用了！</p>
<p>下面，我们就用上面的学习规则来模拟感知机的学习过程。假设<i>w</i><sub>1</sub>和<i>w</i><sub>2</sub>初始值分别为1和-1（注意：已经不再是1和1了！），阈值<i>θ</i>依然为0（事实上为其它初值，也是可行的），那么我们遵循如下步骤，即可完成判定西瓜的学习：</p>
<p>（1）计算判定西瓜的输出值<i>f</i>：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2MzNDgyZDU3YjE3ODY1NjQzNTM4OTExZmFjZWI5Y2JmYTk0ZWFmZWMuanBlZw==.jpg"></p>
<p>将这个输出值带入如图5-2-b所示的阶跃函数中，可得<i>y=0</i>。</p>
<p>（2）显然，针对西瓜，我们期望输出的正确判定是：<i>y</i>=1，而现在实际输出的值<i>y’=0</i>，也就是说，实际输出有误。这个时候，就需要纠偏。而纠偏，就需要利用公式（5.1）所示的学习规则。于是，我们需要计算出来误差<i>ep</i>来。</p>
<p>（3）计算误差<i>ep</i>：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzY4NWYyMGY2NTgxZTlmN2E1M2ZiNjM2MTM5MDg2NTYxMTY3NjMzOWIuanBlZw==.jpg"></p>
<p>现在，我们把<i>ep</i>的值带入公式（5.1）所示的规则中，更新网络的权值和阈值，即：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2E3NTdhZmQzZjAyNjkzYTk5MzFkNTY1OGZkYTVjYWU5YjM0Njg4NDEuanBlZw==.jpg"></p>
<p>（3）那么，在新一轮的网络参数（即权值、阈值）重新学习获得后，我们再次输入西瓜的属性值，来测试一下，看看它能否正确判定：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRjZmIwYjUxMjAyNzU0OTEwYTFmYjdlNWFlOWZiMmEzYTllNmU0ZDkuanBlZw==.jpg"></p>
<p>     再经过激活函数（阶跃函数）处理后，输出结果<i>y</i>=1，很高兴，判定正确！</p>
<p>   （4）我们知道，一个对象的类别判定正确，不算好，“大家好，才算真的好！”于是，在判定西瓜正确后，我们还要尝试在这样的网络参数下，看看香蕉的判定是否也是正确的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2RmODY2Zjg3MWNkYjdmMTIzZmU4MjgzNDU3Y2EwODQ5NjJkY2I5ZTUuanBlZw==.jpg"></p>
<p>类似地，经过激活函数（阶跃函数）处理后，输出结果<i>y</i>=0，判定也正确的！BINGO！误差<i>ep</i>为0，打完收工，学习结束！</p>
<p>在这个案例里，仅仅经过一轮的“试错法（trial-by-error）”，我们就搞定了参数的训练，但你可别高兴太早，谁叫这是一个“Hello World”版本的神经网络呢！事实上，在有监督的学习规则中，我们需要根据输出与期望值的“落差”，经过多轮重试，反复调整神经网络的权值，直至这个“落差”收敛到能够忍受的范围之内，训练才告结束。</p>
<p>在上面，我们仅仅给出了感知机学习的一个感性例子，下面我们要给出感知机学习的形式化的描述。</p>
<h2>5.4 感知机的训练法则</h2>
<p>通过前面的分析，我们可以看到，感知机是很容易实现逻辑上的“与（AND）”、“或（OR）”、“非（NOT）”等原子布尔函数（Primitive Boolean function），如图5-3所示（睿智如你，你肯定发现了，这里的确没有“异或”，这个坑回头我们在后面再填上）[2]。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzZjYzlkYmIwNzY5NWM4YzZiNjE5NmEzYWJlMTVlMDE5NGFhODc4MWQuanBlZw==.jpg"></p>
<p>图5-3 感知机实现逻辑运算</p>
<p>下面举例说明。首先，我们注意到，假设<i>f</i>是如图5-3所示的阶跃函数，通过合适的权值和阈值，即可完成常见的逻辑运算（既然是逻辑运算，<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>都只能取值为0或1），例如：</p>
<p>（1）“与(<i>x</i><sub>1</sub>∧<i>x</i><sub>2</sub>)”：当权值<i>w</i><sub>1</sub><i>=w</i><sub>2</sub>=1，阈值<i>θ</i>=2时，有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2E3MzkyYTgyMzM5YzMzODY0M2Q3YzY4ZjAzODdlMzczOWVjMTkzOWQuanBlZw==.jpg"></p>
<p>此时，仅当<i>x</i><sub>1</sub>=<i>x</i><sub>2</sub>=1时，<i>y</i>=1，而在其它情况下（如<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>无论哪一个取0），<i>y</i>=0。这样，我们在感知机中，就完成了逻辑“与”的运算。</p>
<p>（2）类似地，“或(<i>x</i><sub>1</sub>∨<i>x</i><sub>2</sub>)”：当<i>w</i><sub>1</sub><i>=w</i><sub>2</sub>=1，阈值<i>θ</i>=0.5时，有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzEyYTE2M2ZjMjczZWU5YWFiM2I5NTA5MWJjZGU2OTI0NjRkYjJhMmUuanBlZw==.jpg"></p>
<p>此时，当<i>x</i><sub>1</sub>或<i>x</i><sub>2</sub>中有一个为“1”时，那么<i>y</i>=1，而在其它情况下（即<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>均都取“0”），<i>y</i>=0。这样，我们就完成了逻辑“或”的运算。</p>
<p>（3）在类似地，“非(┐<i>x</i><sub>1</sub>)”：当<i>w</i><sub>1</sub>=0.6，<i>w</i><sub>2</sub>=,0，阈值<i>θ</i>=0.5时，有：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2Q1MjhmZDI2NTlhM2M4YmQ0MGQzMTZkODcxYTFjM2YyOWNmN2VmZmUuanBlZw==.jpg"></p>
<p>此时，当<i>x</i><sub>1</sub>为“1”时，<i>y</i>=0，当<i>x</i><sub>1</sub>为“0”时，<i>y</i>=1。这样，就完成了逻辑“非”的运算（当然，如果以<i>x</i><sub>2</sub>做“非”运算，也是类似操作，这里不再赘述）。</p>
<p>更一般地，当我们给定训练数据，神经网络中的参数（权值<i>w</i><sub>i</sub>和阈值<i>θ</i>）都可以通过不断地“纠偏”学习得到。为了方便起见，我们把阈值<i>θ</i>视为<i>w</i><sub>0</sub>，而其权值设为固定值“-1”，那么阈值<i>θ</i>就可视为一个“哑节点（dummy node）”。这样一来，权重和阈值的学习可以“一统天下”称为“权重”的学习。</p>
<p>如此一来，感知机的学习规则就可以更加简单明了，对于训练样例（<b><i>x</i></b>，<i>y</i>）（需要注意的是，这里粗体字<b><i>x</i></b>表示训练集合），若当前感知机的实际输出y’，假设它不符合预期，存在“落差”，那么感知机的权值依据如公式（5.2）规则调整：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzQ3ODFlNDc1ODdmNjJmMTYyMmU4OGZjZjllNmI0NjdjMzBjYmYwZjQuanBlZw==.jpg">         </p>
<p>其中，<i>η</i>∈(0,1)称为学习率(learning rate)，公式（5.2）其实是公式（5.1）的一般化描述。由公式（5.2）可知，如果（<b><i>x</i></b>，<i>y</i>）预测正确，那么可知<i>y</i>=<i>y</i>’，感知机的权值就不会发生任何变化，否则就会根据“落差”的程度做对应调整。</p>
<p>这里需要注意的是，学习率<i>η</i>的作用是“缓和”每一步权值调整强度的。它本身的大小，也是比较难以确定的。如果<i>η</i>太小，网络调参的次数就太多，从而收敛很慢。如果<i>η</i>太大，“步子大了，容易扯着蛋”，从而错过了网络的参数的最优解。因此，合适的<i>η</i>大小，在某种程度上，还依赖于人工经验（如图5-4所示）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzE3MzY0MTkwM2NlMjgyYTAxYjY1OWU2ZjkxNzY5YTEzMDdmNjM1OGUuanBlZw==.jpg"></p>
<p>图5-4  学习率：“步子大了，容易扯着蛋”</p>
<h2>5.5 感知机的表征能力</h2>
<p>如果识别对象<b><i>x</i></b>有<i>n</i>个特征，那么感知机可以看做，在<i>n</i>维实例空间（即点空间）中的超平面决策面，以向量的模式写出来就是如图5-5所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzA1YmI4ZGUyZmMyNTJmYzdjZjEyZTQzZmRjNDVmYjViZjc2ZmRmYWMuanBlZw==.jpg"></p>
<p>图5-5 感知机的超平面</p>
<p>这样一来的话，对于超平面一侧的实例，感知机输出为1（或称判定为某一类），而对于超平面的另外一侧实例，感知机输出为0（判定为另外一类）。</p>
<p>由于感知机只有输出层神经元可以进行激活函数的处理，也就是说它只拥有单层的功能元神经元（functional neuron），因此它的学习能力是相对有限的。比如说在5.4小节中，原子布尔函数中的“与、或、非”等问题都是线性可分的（linearly separable）的问题。</p>
<p>前面的章节中，我们提到的那位人工智能泰斗明斯基（Minsky）已经证明，若两类模式是线性可分的，那么一定存在一个线性超平面可以将它们区分开来，如图5-6(a)-(c)所示。也就是说，这样的感知机，其学习过程一定会稳定（即收敛）下来，神经网络的权值可以学习得到。</p>
<p>但是对于线性不可分原子布尔函数（如“异或”操作），就不存在简单地线性超平面将其区分开来（如图5-6-(d)）。在这种情况下，感知机的学习过程就会发生“震荡（fluctuation）”，权值向量就难以求得合适解。这里稍微为非专业读者解释一下什么异或？所谓异或（XOR），就是当且仅当输入值<i>x</i><sub>1</sub>和<i>x</i><sub>2</sub>不相等，则输出为1。反之，输出为0。你可以简单粗暴地把“异或”理解为：男欢女爱输出为1，搞基都是没有结果的（输出为0）！</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzNiMGFiODEyMzE1ZDhjOTllYjVhM2I0YmUzZTZkNTVlNzFlMjZmNTUuanBlZw==.jpg"></p>
<p>图5-6 线性可分的“与、或、非”和线性不可分的“异或”</p>
<p>一个寄以厚望的感知机，居然连简单的“异或”功能都实现不了，这点让明斯基颇为失望。于是，在1969年，他和同事Papert合作写下《感知机》一书[3]，直接把“感知机”判了个<i>n</i>年有期徒刑（<i>n</i>在当时为不可知变量）。</p>
<p>这么一说，好像明斯基是一位法官一样。但其实呢，他更像《白雪公主》里的那位继母王后。这是因为就是他，给那个叫“人工智能”的“白雪公主”喂了一颗“毒苹果”（《感知机》一书），让这位“白雪公主”一睡就是20年（<i>n</i>=20）。</p>
<p>我们知道，绝大多数童话都有个“happy ending（完美结局）”，《白雪公主》也不例外。现在我们好奇的是，在人工智能领域，谁又是那位“吻醒”白雪公主的“王子”呢？</p>
<p>欲知后事如何，且听我们下回分解。</p>
<h2>5.6小结</h2>
<p>在本小节，我们首先用西瓜和香蕉的判定案例，感性地谈了谈感知机的工作流程。然后，我们又给出了感知机的形式化学习规则以及感知机的表征能力。容易发现，感知机连常见的逻辑操作“异或”都难以实现，这一功能缺陷，直接让人工智能领域大神明斯基抓住了“小辫子”，然后就把“人工智能”送进了长达二十年的“冬天”。</p>
<p>但英国浪漫主义诗人雪莱说了：“冬天来了，春天还会远吗？”</p>
<h2>5.7 请你思考</h2>
<p>学习完本小节，请你思考如下问题：</p>
<p>（1）你能参照感知机判定“西瓜”和“香蕉”的案例，训练感知机完整布尔函数“与、或、非”等权值的学习吗？请用编程语言实现。（提示：它山之石，可以攻玉。可以借助开源的神经网络框架实现，如由Java语言编写的Neuroph，下载链接：<a href="http://neuroph.sourceforge.net/" rel="external nofollow noreferrer">http://neuroph.sourceforge.net/</a>）</p>
<p>（2）你知道最终感知机是如何解决“异或”问题的吗？（提前剧透：增加神经网络的层数，提升网络数据特征的表达能力，网络层次多了，这就是深度神经网络啊！）</p>
<p>写下你的感悟，祝你每天都有收获！</p>
<h2>【参考文献】</h2>
<p>[1]<br />
吴岸城. 神经网络与深度学习.电子工业出版社.2016.6</p>
<p>[2]<br />
周志华.机器学习.清华大学出版社.2016.2</p>
<p>[3] Minsky<br />
M, Papert S. Perceptrons[J]. 1969.</p>
<p>文章作者：张玉宏（著有《<a href="http://product.dangdang.com/24048575.html" rel="external nofollow noreferrer">品味大数据</a>》一书），审校：我是主题曲哥哥。</p>
<p><b>（未完待续）</b></p>
<p><b>系列文章：</b></p>
<p>损失函数减肥用，神经网络调权重（深度学习入门系列之六）</p>
<p>山重水复疑无路，最快下降问梯度（深度学习入门系列之七）</p>
<p>BP算法双向传，链式求导最缠绵（深度学习入门系列之八）</p>
<p>全面连接困何处，卷积网络见解深（深度学习入门系列之九）</p>
<p>卷地风来忽吹散，积得飘零美如画（深度学习入门系列之十）</p>
<p>局部连接来减参，权值共享肩并肩（深度学习入门系列之十一）</p>
<p>激活引入非线性，池化预防过拟合（深度学习入门系列之十二）</p>
<p>循环递归RNN，序列建模套路深（深度学习入门系列之十三）</p>
<p>LSTM长短记，长序依赖可追忆（深度学习入门系列之十四）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:13:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0/" title="深度学习">深度学习</a>, <a href="https://www.iamivan.net/tag/%e6%9c%ba%e5%99%a8%e5%ad%a6%e4%b9%a0/" title="机器学习">机器学习</a>, <a href="https://www.iamivan.net/tag/%e7%a5%9e%e7%bb%8f%e7%bd%91%e7%bb%9c/" title="神经网络">神经网络</a>, <a href="https://www.iamivan.net/tag/%e4%ba%ba%e5%b7%a5%e6%99%ba%e8%83%bd/" title="人工智能">人工智能</a>, <a href="https://www.iamivan.net/tag/%e5%93%81%e5%91%b3%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="品味大数据">品味大数据</a>, <a href="https://www.iamivan.net/tag/%e5%bc%a0%e7%8e%89%e5%ae%8f/" title="张玉宏">张玉宏</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Hello World感知机，懂你我心才安息 (深度学习入门系列之五)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRA3lz.html" rel="bookmark">一篇文章搞懂人工智能、机器学习和深度学习之间的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 2015年11月9日,Google发布人工智能系统TensorFlow并宣布开源.这两年在不管在国内还是在国外,人工智能.机器学习仿佛一夜之前传遍大街小巷.机器学习作为人工智能的一种类型,可以让软件根据大量的数据来对未来的情况进行阐述或预判.如今,领先的科技巨头无不在机器学习下予以极大投入.Facebook.苹果.微软,甚至国内的百度,Google 自然也在其中. 去年早些时候 Google DeepMind 的 AlphaGo 项目在举世瞩目的围棋比赛中一举击败了韩国选手李世石,媒体就是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZgVdb.html" rel="bookmark">简单读懂人工智能：机器学习与深度学习是什么关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言:随着AlphaGo战胜李世石,人工智能和深度学习这些概念已经成为一个非常火的话题.人工智能.机器学习与深度学习这几个关键词时常出现在媒体新闻中,并错误地被认为是等同的概念.本文将介绍人工智能.机器学习以及深度学习的概念,并着重解析它们之间的关系.本文将从不同领域需要解决的问题入手,依次介绍这些领域的基本概念以及解决领域内问题的主要思路. 本文选自&lt;Tensorflow:实战Google深度学习框架&gt;. 从计算机发明之初,人们就希望它能够帮助甚至代替人类完成重复性劳作.利用巨大的存储空间和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeamyAz.html" rel="bookmark">（转）神经网络和深度学习简史（第一部分）：从感知机到BP算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    深度|神经网络和深度学习简史(第一部分):从感知机到BP算法 2016-01-23 机器之心 来自Andrey Kurenkov 作者:Andrey Kurenkov 机器之心编译出品 参与:chenxiaoqing.范娜Fiona.杨超.微胖.汪汪.赵巍   导读:这是&lt;神经网络和深度学习简史&gt;第一部分.这一部分,我们会介绍1958年感知机神经网络的诞生,70年代人工智能寒冬以及1986年BP算法让神经网络再度流行起来.   深度学习掀起海啸     如今,深度学习浪潮拍打计算机语言			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGJnnp.html" rel="bookmark">综述 &vert; 一文读懂自然语言处理NLP（附学习资料）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 自然语言处理是文本挖掘的研究领域之一,是人工智能和语言学领域的分支学科.在此领域中探讨如何处理及运用自然语言. 对于自然语言处理的发展历程,可以从哲学中的经验主义和理性主义说起.基于统计的自然语言处理是哲学中的经验主义,基于规则的自然语言处理是哲学中的理性主义.在哲学领域中经验主义与理性主义的斗争一直是此消彼长,这种矛盾与斗争也反映在具体科学上,如自然语言处理. 早期的自然语言处理具有鲜明的经验主义色彩.如 1913 年马尔科夫提出马尔科夫随机过程与马尔科夫模型的基础就是&quot;手工查频&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8ZPVPb.html" rel="bookmark">独家 &vert; 一文读懂自然语言处理NLP（附学习资料）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言                                               自然语言处理是文本挖掘的研究领域之一,是人工智能和语言学领域的分支学科.在此领域中探讨如何处理及运用自然语言. 对于自然语言处理的发展历程,可以从哲学中的经验主义和理性主义说起.基于统计的自然语言处理是哲学中的经验主义,基于规则的自然语言处理是哲学中的理性主义.在哲学领域中经验主义与理性主义的斗争一直是此消彼长,这种矛盾与斗争也反映在具体科学上,如自然语言处理. 早期的自然语言处理具有鲜明的经验主义			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkG8r1p.html" rel="bookmark">【2万赞】一文读懂深度学习（附学习资源）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Image credit: Datanami   人工智能(AI)和机器学习(ML)都属于目前最热门的话题. 在日常生活中,AI这个术语我们随处可见.你或许会从立志高远的开发者那里听说她(他)们想要学习AI.你又或许会从运营者那里听到他们想要在他们的的服务中实施AI.但往往这些人中的绝大多数都并不明白什么是AI. 在你阅读完这篇文章之后,你将会了解AI和ML的基本知识.而更重要的是,你将会明白深度学习(https://en.wikipedia.org/wiki/Deep_learning),这类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXweOKM.html" rel="bookmark">独家 &vert; 一文读懂TensorFlow（附代码、学习资料）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				人工智能.机器学习和深度学习 在介绍TensorFlow(以下简称为TF)之前,我们首先了解一下相关背景. TF是一种机器学习框架,而机器学习经常和人工智能,深度学习联系在一起,那么三者到底是什么关系呢? 简单来讲三者可以理解为包含于被包含的关系.其中最大的是人工智能(以下简称为AI),AI最早起源于1956年的达特茅斯会议,当时AI的几位先驱在会上展示了最早的AI程序:Logic Theorist,能够自动推导数学原理第二章前52个定理中的38个,甚至其中一个定理的证明过程比书中给出的还要优雅			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJA4JDp.html" rel="bookmark">深度学习要多深，才能读懂人话？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				研究背景 阿里小蜜是阿里巴巴推出的围绕电商服务.导购以及任务助理为核心的智能人机交互产品,在去年双十一期间,阿里小蜜整体智能服务量达到643万,其中智能解决率达到95%,成为了双十一期间服务的绝对主力.阿里小蜜所使用的问答技术也在经历着飞速的发展,从最初基于检索的知识库问答演进到了最新的语义深度建模. 近期,阿里小蜜正在开展新的探索,让机器具有如同人一般的阅读理解能力,这将使得问答产品体现出真正的智能,进一步提升服务效率. 在问答技术中,最常见的是检索式问答,但存在很多的限制,例如,需要人工进行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M192woM.html" rel="bookmark">一文看懂深度学习在语音合成&amp;amp&semi;增强上的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文作者刘斌,中科院自动化所博士,极限元资深智能语音算法专家,中科院-极限元智能交互联合实验室核心技术人员,曾多次在国际顶级会议上发表论文,获得多项关于语音及音频领域的专利,具有丰富的工程经验. 深度学习在 2006 年崭露头角后,近几年来取得了快速发展,在学术界和工业界均呈现出指数级增长的趋势:伴随着这项技术的不断成熟,深度学习在智能语音领域率先发力,取得一系列成功的应用.本文将重点分享近年来深度学习在语音生成问题中的新方法,围绕语音合成和语音增强两个典型问题展开介绍. 一.深度学习在语音合成中			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgwP3M.html" rel="bookmark" class="title">U-Time巡回完美收官 演讲嘉宾干货分享：数据篇</a>
					<div>
						导读:&quot;如何开展更贴近业务的数据分析,如何更高效的进行垂直化运营&quot;这是很多企业面临的问题,绕不开的一道坎.日前,[友盟+]U-Time巡回沙龙于7月12日落下帷幕,解答了该问题.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ68rM.html" rel="bookmark" class="title">十大愚蠢互联网趋势</a>
					<div>
						美国&lt;广告时代&gt;杂志近日发表分析文章,指出了十大互联网愚蠢趋势,很多人认为,互联网媒体已经度过了疯狂.无序的时代,但事实也许正好相反.现在出现了越来越多轻率.不成熟的网络内容方案,至少90 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR6YqM.html" rel="bookmark" class="title">制作节日logo 敲开2011元旦LOGO设计</a>
					<div>
						又到新年,先祝大家节日快乐.在元旦佳节之际,妈妈首页logo也换上新装. 这里就给大家分享下这个logo整个创意及制作的心得. 做这个logo前,先明确下目的和功能:1时令性.2趣味性.作为元旦的lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2OKqM.html" rel="bookmark" class="title">喜欢伪原创的人必须知道的几个事情</a>
					<div>
						本人是从事医疗行业搜索引擎营销的,相信做过医疗行业推广或者编辑的朋友,应该都很清楚,比如不孕不育领域吧,随便搜一个病种的治疗方法,百度搜索出来的结果当中,点进去一看,内容基本都一样,这说明大家&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kJwqz.html" rel="bookmark" class="title">MS SQL基础教程：索引调整向导</a>
					<div>
						8.5.1 索引与系统性能 索引可以加快数据检索的速度,但它会使数据的插入.删除和更新变慢.尤其是簇索引,数据是按照逻辑顺序存放在一定的物理位置,当变更数据时,根据新的数据顺序,需要将许多数据进行物理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKL9ZM.html" rel="bookmark" class="title">Qt学习之路&lpar;5&rpar;：组件布局</a>
					<div>
						顾名思义,绝对定位就是使用最原始的定位方法,给出这个组件的坐标和长宽值.这样,Qt就知道该把组件放在哪里,以及怎么设置组件的大小了.但是这样做的一个问题是,如果用户改变了窗口大小,比如点击了最大化或者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPxB0z.html" rel="bookmark" class="title">实例jie如何提高Java Web 服务性能优化实践</a>
					<div>
						本文介绍如何提升 Java Web 服务性能,主要介绍了三种方法:一是采用 Web 服务的异步调用,二是引入 Web 服务批处理模式,三是压缩 SOAP 消息.重点介绍在编程过程中如何使用异步 Web ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY26Nlp.html" rel="bookmark" class="title">巧解XP升Win8磁盘问题</a>
					<div>
						Win8正式版已经发布多时了,很多用户都希望能将原有的系统(Windows XP.Windows 7)升级到最新的Win8正版,升级的具体方法包括通过Win8启动盘(制作U盘购买正版key).通过官方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7qKOM.html" rel="bookmark" class="title">360安全卫士防护弹窗怎么设置成自动处理模式？</a>
					<div>
						  1.打开开始菜单,点击如下图红色箭头所示&quot;360安全卫士&quot;程序图标. 2.点击如下图红色箭头所示倒三角按钮. 3.在弹出的二级菜单中点击&quot;设置&quot;菜单项. 4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjaZjb.html" rel="bookmark" class="title">如何获取网页中按钮的地址？</a>
					<div>
						问题描述 如何获取网页中按钮的地址? 例如http://contest.i21st.cn/zhuanti/20th/final.php?from=timeline&amp;isappinstalled ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA22EM.html" rel="bookmark" class="title">Python实现竖排打印传单手机号码易撕条&lowbar;python</a>
					<div>
						使用python 2.7,初学,代码比较简单. numPrinter.py 复制代码 代码如下: #!/usr/bin/env python # -*- coding: utf-8 -*- '''   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4Nk18M.html" rel="bookmark" class="title">数据寻龙点穴（空间聚集分析） - 阿里云RDS PostgreSQL最佳实践</a>
					<div>
						标签 PostgreSQL , Greenplum , PostGIS , K-Mean , 热力图 背景 最近鬼吹灯热播,胡八一的&lt;十六字阴阳风水秘术&gt;到底是什么武功秘籍?寻龙点穴又是什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQxJap.html" rel="bookmark" class="title">TensorFlow教程之API DOC 6&period;3&period;8&period; IO OPS</a>
					<div>
						本文档为TensorFlow参考文档,本转载已得到TensorFlow中文社区授权. Inputs and Readers Note: Functions taking Tensor argument ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32x50z.html" rel="bookmark" class="title">React动画框架简介</a>
					<div>
						由于 React 加持了虚拟 DOM 等诸多特性,所以在 React 上实现常规的动画效果有一些特别之处.本文不会深入探讨 React 对动画的处理逻辑,只会简单地演示如何使用 React 创建动画效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX3Emz.html" rel="bookmark" class="title">中文女和程序员的爱情奇遇</a>
					<div>
						&quot;我所认为最深沉的爱,莫过于分开以后,我将自己,活成了你的樣子&quot;.--写给所有热爱互联网和相信爱情的人.菜菜是个开朗乐观的 90 后小文艺少女,随和开放.饭饭是个睿智严谨的 80  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKWKLb.html" rel="bookmark" class="title">《解读NoSQL》&mdash;&mdash;2&period;2　将应用分层以简化设计</a>
					<div>
						在架构中采用应用分层的思想可以构建弹性的.可重用的应用.采用应用分层的思想,当必须做出一些改动时,可以选择新增或者修改某一个特定的层次,而不是重写它.在接下来的例子中,通过比较关系型数据库系统和NoS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RBn7z.html" rel="bookmark" class="title">RHEL&sol;CentOS 恢复磁盘数据三法</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://koumm.blog.51cto.com/703525/1377027 本文采用O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY1PEp.html" rel="bookmark" class="title">nginx 如何将后端squid缓存命中率字段输出到自己的access&period;log当中？</a>
					<div>
						问题描述 nginx 如何将后端squid缓存命中率字段输出到自己的access.log当中? 如题,由于需要统计缓存命中率,缓存后端使用的是squid,有什么办法能将squid的缓存命中率字段打印到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRl4Nb.html" rel="bookmark" class="title">数据-Java如何实现rss搜索功能</a>
					<div>
						问题描述 Java如何实现rss搜索功能 Java 我想做一个新闻搜索的功能,就是想指定搜索rss数据源,然后解析xml到我们自己网站,现在网上大部分资料都是订阅rss,我想做一个具体的搜索功能,搜索 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydkRdb.html" rel="bookmark" class="title">关于两个jQuery&lpar;js&rpar;特效冲突的bug的解决办法&lowbar;jquery</a>
					<div>
						Problem: 使用jquery,json做一个资源下载的应用,其中用到paginate.js和JSON数据的分页效果,以及jquery.DOMWindow.js的弹窗效果. 但是出现以下bug:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7XNXp.html" rel="bookmark" class="title">文件系统函数库：lstat</a>
					<div>
						lstat (PHP3 &gt;= 3.0.4 , PHP4) lstat ---&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myev5ZM.html" rel="bookmark" class="title">Jquery实现的角色左右选择特效&lowbar;jquery</a>
					<div>
						复制代码 代码如下: &lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt; &lt;head&gt; &lt;meta http-eq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL1WqM.html" rel="bookmark" class="title">Oracle中删除用户和表空间的常见问题&lpar;比如：ORA-01940无法删除当前已连接用户的解决方案&rpar;</a>
					<div>
						这时候以管理员身份进入sqlplus命令窗口. 在删除用户的时候有时候会出现以下问题: ORA-01940无法删除当前已连接用户 这时候的解决方案是: 1)查看用户的连接状况   select use ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdywdNz.html" rel="bookmark" class="title">纪源资本喜迎丰收年 做PE&OpenCurlyDoubleQuote;三分投七分管&rdquo;</a>
					<div>
						&quot;我们今年的业绩,估计会超出整个历史最好的时期.&quot;电话那头的卓福民满怀自豪地说. 卓福民是纪源资本管理合伙人. 纪源资本的最新业绩是冠昊生物在创业板上市. 2011年7月6日,冠昊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QXXXM.html" rel="bookmark" class="title">利用C&plus;&plus;实现矩阵的相加&sol;相称&sol;转置&sol;求鞍点&lowbar;C 语言</a>
					<div>
						1.矩阵相加 两个同型矩阵做加法,就是对应的元素相加. 复制代码 代码如下: #include&lt;iostream&gt;using namespace std;int main(){ int a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvVrPM.html" rel="bookmark" class="title">php获取json数据所有的节点路径&lowbar;php技巧</a>
					<div>
						之前我们讲解过使用javascript获取json数据节点路径的问题,今天我们更进一步,讲解下php获取json数据所有的节点路径 &lt;?php function iterTree($data)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0N27p.html" rel="bookmark" class="title">javascript实现10个球随机运动、碰撞实例详解&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了javascript实现10个球随机运动.碰撞的方法.分享给大家供大家参考.具体如下: 学了一段时间的javascript了,做过一些小案例,目前最有难度的就是10个小球随机碰撞效果,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYDDNb.html" rel="bookmark" class="title">jQuery弹出层插件Lightbox&lowbar;me使用指南&lowbar;jquery</a>
					<div>
						网站开发过程中,为了增加网站交互效果,我们有时需要在当前页面弹出诸如登陆.注册.设置等窗口.而这些窗口就是层,弹出的窗口就是弹出层.jQuery中弹出层插件很多,但有些在html5+css3浏览器下, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnPxqp.html" rel="bookmark" class="title">用Dotfuscator进行混淆的时候出现Invalid input assembly</a>
					<div>
						问题描述 如图,准备添加编译好的Dll出现这个问题,各位大神怎么说?!!!求助啊..					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvZkoM.html" rel="bookmark" class="title">openstack实例创建问题</a>
					<div>
						问题描述 openstack在创建实例的时候,如果指定的硬盘大小,比单个节点硬盘剩余的大小还大,会不会使用另外节点的磁盘空间.同理,分配的内存比单个节点的内存还要大,那么实例会不会使用其他节点的磁盘空 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
